--
--Caruelle
--
--@poc@lypse
--

Caruelle = {};

function Caruelle.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;


function Caruelle:load(xmlFile)
            print("'lua loaded '" );

	
	
	self.sprayValves = {};
	
	 local psFile = getXMLString(xmlFile, "vehicle.sprayParticleSystem#file");
    if psFile ~= nil then
        local i=0;
        while true do
            local baseName = string.format("vehicle.sprayValves.sprayValve(%d)", i);
            local node = getXMLString(xmlFile, baseName.. "#index");
            if node == nil then
                break;
            end;
            node = Utils.indexToObject(self.components, node);
            if node ~= nil then
                local sprayValve = {};
                sprayValve.particleSystems = {};
                Utils.loadParticleSystem(xmlFile, sprayValve.particleSystems, "vehicle.sprayParticleSystem", node, false, nil, self.baseDirectory);
                table.insert(self.sprayValves, sprayValve);
            end;
            i = i+1;
        end;
    end;
      local numCuttingAreas = getXMLInt(xmlFile, "vehicle.cuttingAreas#count");
	 self.cuttingAreas = {}
    for i=1, numCuttingAreas do
        self.cuttingAreas[i] = {};
        local areanamei = string.format("vehicle.cuttingAreas.cuttingArea" .. "%d", i);
        local x,y,z = getTranslation(getChildAt(self.rootNode, getXMLInt(xmlFile, areanamei .. "#startIndex")));
        local widthX, widthY, widthZ = getTranslation(getChildAt(self.rootNode, getXMLInt(xmlFile, areanamei .. "#widthIndex")));
        local heightX, heightY, heightZ = getTranslation(getChildAt(self.rootNode, getXMLInt(xmlFile, areanamei .. "#heightIndex")));
        self.cuttingAreas[i].startX = x;
        self.cuttingAreas[i].startZ = z;
        self.cuttingAreas[i].width = widthX-x;
        self.cuttingAreas[i].height = heightZ-z;
    end;
	
	   local tipAnimRootNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tipAnimation#rootNode"));
    self.tipAnimCharSet = 0;
    if tipAnimRootNode ~= nil and tipAnimRootNode ~= 0 then
        self.tipAnimCharSet = getAnimCharacterSet(tipAnimRootNode);
        if self.tipAnimCharSet ~= 0 then
            local clip = getAnimClipIndex(self.tipAnimCharSet, getXMLString(xmlFile, "vehicle.tipAnimation#clip"));
            assignAnimTrackClip(self.tipAnimCharSet, 0, clip);
            setAnimTrackLoopState(self.tipAnimCharSet, 0, false);
            self.tipAnimSpeedScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.tipAnimation#speedScale"), 1);
            self.tipAnimDuration = getAnimClipDuration(self.tipAnimCharSet, clip);
            if self.tipDischargeEndTime == nil then
                self.tipDischargeEndTime = self.tipAnimDuration*2.0;
            end;
        end;
    end;
	
	local translationPartNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart#index"));
    if translationPartNode ~= nil then
        self.translationPart = {};
        self.translationPart.node = translationPartNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart#minTrans"));
        self.translationPart.minTrans = {};
        self.translationPart.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart.minTrans[3] = Utils.getNoNil(z, 0);
	print ("load doTranslate and transMax")
        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart#maxTrans"));
        self.translationPart.maxTrans = {};
        self.translationPart.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart#transTime"), 2)*1000;
        self.translationPart.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart#touchTransLimit"), 10);
    end;
    self.capacity = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.capacity"), 0.0);
    self.output = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.eauOutput"), 2.0); 

	local translationPartNode3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart3#index"));
    if translationPartNode3 ~= nil then
        self.translationPart3 = {};
        self.translationPart3.node = translationPartNode3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart3#minTrans"));
        self.translationPart3.minTrans = {};
        self.translationPart3.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart3.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart3.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart3#maxTrans"));
        self.translationPart3.maxTrans = {};
        self.translationPart3.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart3.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart3.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart3.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart3#transTime"), 2)*1000;
        self.translationPart3.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart3#touchTransLimit"), 10);
    end;
	self.deplier = false;
    self.isActive = false; 
	
	
	
end;

function Caruelle:delete()
	Trailer.delete(self);
end;

function Caruelle:mouseEvent(posX, posY, isDown, isUp, button)
    Trailer.mouseEvent(self, posX, posY, isDown, isUp, button);
end;

function Caruelle:keyEvent(unicode, sym, modifier, isDown)
    Trailer.keyEvent(self, unicode, sym, modifier, isDown);
	
	if isDown and sym == Input.KEY_b then
		self:setActive(not self.isActive);
	end;
	
	if isDown and sym == Input.KEY_n then
		self:setDeplier()
	end;
	
	if isDown and sym == Input.KEY_m then
		 self:onEndTip();
	end;
	
	if sym == Input.KEY_j then
		self.translationMax = isDown;
		self.translationMax3 = isDown;
	end;
	if sym == Input.KEY_k then
		self.translationMin = isDown;
		self.translationMin3 = isDown;
	end;
	
end;

function Caruelle:update(dt)
	
	self.isExpanded = true;	
	
		
	if self.isActive then        
		
      for k,cuttingArea in pairs(self.cuttingAreas) do
                local x,y,z = getWorldTranslation(cuttingArea.start);
                local x1,y1,z1 = getWorldTranslation(cuttingArea.width);
                local x2,y2,z2 = getWorldTranslation(cuttingArea.height);
                Utils.updateSprayArea(x, z, x1, z1, x2, z2);
            end;
  
	end;
			
	if self.isExpanded then	
		local doTranslate = self.translationMax or self.translationMin
		if self.translationPart ~= nil and doTranslate then
			--translate = button { }  = isDown
			local x, y, z = getTranslation(self.translationPart.node);
			local trans = {x,y,z};
			local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart.maxTrans, self.translationPart.minTrans, 3, self.translationPart.transTime, dt, not self.translationMax);
			setTranslation(self.translationPart.node, unpack(newTrans));
		end;
		if self.translationPart3 ~= nil and doTranslate then
			--translate = button { }  = isDown
			local x, y, z = getTranslation(self.translationPart3.node);
			local trans = {x,y,z};
			local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart3.maxTrans, self.translationPart3.minTrans, 3, self.translationPart3.transTime, dt, not self.translationMax3);
			setTranslation(self.translationPart3.node, unpack(newTrans));
		end;
	end;
	
	if self.isDeplier then
	 if self.tipAnimCharSet ~= 0 then
        if getAnimTrackTime(self.tipAnimCharSet, 0) < 0.0 then
            setAnimTrackTime(self.tipAnimCharSet, 0, 0.0);
        end;
        setAnimTrackSpeedScale(self.tipAnimCharSet, 0, self.tipAnimSpeedScale);
        enableAnimTrack(self.tipAnimCharSet, 0);
    end;
	end;
	Trailer.update(self, dt);
end;

function Caruelle:draw()
    Trailer.draw(self);
	
	if self.isActive then
		g_currentMission:addExtraPrintText("Touche B: Arreter les rampes");
	else
		g_currentMission:addExtraPrintText("Touche B: Mettre en route les rampes");
	end;
	
	if self.isExpanded then
		g_currentMission:addExtraPrintText("Touche N: Deplier rampes");
	end;
	
	if self.isExpanded then
		g_currentMission:addExtraPrintText("Touche M: Replier les rampes");
	end;
	
	if self.isExpanded then
		g_currentMission:addExtraPrintText("Taste J/K: lever/baisser les rampes");
	end;
end;


function Caruelle:onDetach()
	Trailer.onDetach(self);
	self.isActive = false;	
	self:setActive(false);
end;

function Caruelle:setActive(active)
	self.isActive = active;
	for i=1, table.getn(self.sprayValves) do
        local sprayValve = self.sprayValves[i];
        for j=1, table.getn(sprayValve.particleSystems) do
            setEmittingState(sprayValve.particleSystems[j], self.isActive);
        end;
    end;
end;

function Caruelle:setDeplier()
	 if self.tipAnimCharSet ~= 0 then
        if getAnimTrackTime(self.tipAnimCharSet, 0) < 0.0 then
            setAnimTrackTime(self.tipAnimCharSet, 0, 0.0);
        end;
        setAnimTrackSpeedScale(self.tipAnimCharSet, 0, self.tipAnimSpeedScale);
        enableAnimTrack(self.tipAnimCharSet, 0);
    end;
end;



	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	